import 'dart:async';

import 'package:flutter/services.dart';

typedef void PushCallbackHandler(String name);

class IosSamplePlugin {
  static const MethodChannel _channel =
      MethodChannel('sample_channel_for_demo');
  PushCallbackHandler _onPushClick;

  void initialize() {
    print('inside init');
    _channel.setMethodCallHandler(anySampleMethod);
  }

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  void setUpPushCallbacks(PushCallbackHandler onPushClick) {
    _onPushClick = onPushClick;
  }

  void fetchName() {
    _channel.invokeMethod("defaultMethod");
  }

  Future<dynamic> anySampleMethod(MethodCall call) async {
    print("inside the plugin listener method method");
    _onPushClick(call.arguments.toString());
  }
}
